//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//|                                                   JJMASeries.mqh |
//|                 JMA code: Copyright  2005, Weld, Jurik Research |
//|                                          http://weld.torguem.net |
//|                MQL4+JJMA: Copyright  2006,     Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 
#property copyright "Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
  /*
  SSSSSS <<<  JJMASeries >>> SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS

  -----------------------------  -------------------------------

   JJMASeries     JMA.     ,   
      .    ,        nJMA_limit    ,  ! 
   ,       JJMASeries,          .           
  MetaTrader\experts\include\

  --------------------------    --------------------------

  nJMA_number -      JJMASeries. (0, 1, 2, 3 ......)
  nJMA_dinJ   - ,    nJMA_Length  nJMA_Phase   . 0 -   ,    - .
  nJMA_MaxBar -  ,      (bar).   Bars-1;
  nJMA_limit  -            ,    : Bars-IndicatorCounted()-1;
  nJMA_Length -  
  nJMA_Phase  - ,    -100 ... +100,     ;
  dJMA_series -   ,      JJMASeries;
  nJMA_bar    -   ,          .
  nJMA_reset  - ,     -1        JJMASeries.

  -------------------------   ---------------------------

  JJMASeries() -   dJMA_JMA
  nJMA_reset   - ,    ,   0 ,      ,
   0,    .      ,   !!!

  ---------------------     ---------------------

      JJMASeries ,       0,    
    ,         :
  reset=-1; JJMA(0,MaxJMA.number+1,0,0,0,0,0,0,reset);   JJMASeriesReset(MaxJMA.number+1);
     nJMA_number(MaxJMA.number)      JJMASeries,      , 
   nJMA_number.   nJMA_reset    reset  -1(    -1 !
    ).    0.         JJMASeries, 
        nJMA_...  dJMA_...

  ---------------------     -----------------------
int start()
{
//----+        
int reset,bar,MaxBar,limit,counted_bars=IndicatorCounted(); 
//----    
if (counted_bars<0)return(-1);
//----      
if (counted_bars>0) counted_bars--;
//----     ,        
int limit=Bars-counted_bars-1;
MaxBar=Bars-1;
//----+       JJMASeries, nJMA_number=1(    JJMASeries)
if(limit==Bars-1)JJMASeriesReset(1);
//----+    JJMASeries   0    Ind_Buffer[],  nJMA_Phase  nJMA_Length      (nJMA_din=0)
for(bar=limit;bar>=0;bar--)
 (
  Series=Close[bar];
  Resalt=JJMASeries(0,0,Bars-1,limit,Phase,Length,Series,bar,reset);
  if (reset!=0)return(-1);
  Ind_Buffer[bar]=Resalt;
 }
return(0);
}
//----+   JJMASeries
#include <JJMASeries.mqh>

  ----------      INDICATOR_COUNTED() ------------
int start()
{
//----+        
//----           
int reset,bar,MaxBar,limit,counted_bars=INDICATOR_COUNTED(0); INDICATOR_COUNTED(1);
//----    
if (counted_bars<0){INDICATOR_COUNTED(-1);return(-1);}
//----      
if (counted_bars>0) counted_bars--;
//----     ,        
int limit=Bars-counted_bars-1;
MaxBar=Bars-1;
//----+       JJMASeries, nJMA_number=1(    JJMASeries)
if(limit==Bars-1)JJMASeriesReset(1);
//----+    JJMASeries   0    Ind_Buffer[],  nJMA_Phase  nJMA_Length      (nJMA_din=0)
for(bar=limit;bar>=0;bar--)
 (
  Series=Close[bar];
  Resalt=JJMASeries(0,0,Bars-1,limit,Phase,Length,Series,bar,reset);
  if (reset!=0){INDICATOR_COUNTED(-1);return(-1);}
  Ind_Buffer[bar]=Resalt;
 }
return(0);
}
//----+   JJMASeries  INDICATOR_COUNTED
#include <JJMASeries.mqh>

  */
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//+++++++++++++++++++++++++++++++++++++++++++++++++++++ <<< JJMASeries >>> ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+

double JJMASeries
(int nJMA_number,int nJMA_din,int nJMA_MaxBar,int nJMA_limit,int nJMA_Phase,int nJMA_Length,double dJMA_series,int nJMA_bar,int& nJMA_reset)
{
if(nJMA_reset==-1)
{
//----++ <<<     >>> +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
static double dJMA_f18[1],dJMA_f38[1],dJMA_fA0,dJMA_fA8[1],dJMA_fC0[1],dJMA_fC8[1],dJMA_s8[1],dJMA_s18[1],dJMA_vv,dJMA_v1[1],dJMA_v2[1];
static double dJMA_v3[1],dJMA_v4,dJMA_f90[1],dJMA_f78[1],dJMA_f88[1],dJMA_f98[1],dJMA_JMA[1],dJMA_list[1][128],dJMA_ring1[1][128];
static double dJMA_ring2[1][11],dJMA_buffer[1][62],dJMA_mem1[1][8],dJMA_mem3[1][128],dJMA_mem4[1][128],dJMA_mem5[1][11],dJMA_f70;
static double dJMA_mem8[1][128],dJMA_Kg[1],dJMA_Pf[1],dJMA_s20,dJMA_s10,dJMA_fB0,dJMA_fD0,dJMA_f8,dJMA_f60,dJMA_f20,dJMA_f28;
static double dJMA_f30,dJMA_f40,dJMA_f48,dJMA_f58,dJMA_f68;
static int    nJMA_s28[1],nJMA_s30[1],nJMA_s38[1],nJMA_s40[1],nJMA_v5,nJMA_v6,nJMA_fE0,nJMA_fD8,nJMA_fE8,nJMA_val,nJMA_s48[1];
static int    nJMA_s58,nJMA_s60,nJMA_s68,nJMA_f0[1],nJMA_aa,nJMA_temp,nJMA_size,nJMA_s50[1],nJMA_s70[1],nJMA_LP2[1],nJMA_LP1[1];
static int    nJMA_countR1[1],nJMA_countR2[1],nJMA_countL[1],nJMA_ii,nJMA_jj,nJMA_n,nJMA_m,nJMA_mem2[1][9],nJMA_mem6[1][128];
static int    nJMA_mem7[1][11],nJMA_mem9[1][128];
//--+
nJMA_m=nJMA_number;
if(ArrayResize(dJMA_list,   nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(dJMA_ring1,  nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(dJMA_ring2,  nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(dJMA_buffer, nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(dJMA_mem1,   nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(nJMA_mem6,   nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(nJMA_mem2,   nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(nJMA_mem7,   nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(dJMA_mem3,   nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(dJMA_mem8,   nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(dJMA_mem4,   nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(nJMA_mem9,   nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(dJMA_mem5,   nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(nJMA_countR1,nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(nJMA_countR2,nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(nJMA_countL ,nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(dJMA_Kg,     nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(dJMA_Pf,     nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(dJMA_f18,    nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(dJMA_f38,    nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(dJMA_fA8,    nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(dJMA_fC0,    nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(dJMA_fC8,    nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(dJMA_s8,     nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(dJMA_s18,    nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(dJMA_JMA,    nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(nJMA_s50,    nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(nJMA_s70,    nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(nJMA_LP2,    nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(nJMA_LP1,    nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(nJMA_s38,    nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(nJMA_s40,    nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(nJMA_s48,    nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(dJMA_v1,     nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(dJMA_v2,     nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(dJMA_v3,     nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(dJMA_f90,    nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(dJMA_f78,    nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(dJMA_f88,    nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(dJMA_f98,    nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(nJMA_s28,    nJMA_m)==0){nJMA_reset=1;return(0);}if(ArrayResize(nJMA_s30,    nJMA_m)==0){nJMA_reset=1;return(0);}
if(ArrayResize(nJMA_f0,     nJMA_m)==0){nJMA_reset=1;return(0);}
//--+
ArrayInitialize(dJMA_list,0.0);ArrayInitialize(dJMA_ring1,0.0);ArrayInitialize(dJMA_ring2,0.0);ArrayInitialize(dJMA_buffer,0.0);
ArrayInitialize(dJMA_mem1,0.0);ArrayInitialize(nJMA_mem2, 0  );ArrayInitialize(dJMA_mem3, 0.0);ArrayInitialize(dJMA_mem4,  0.0);
ArrayInitialize(dJMA_mem5,0.0);ArrayInitialize(nJMA_mem6, 0  );ArrayInitialize(nJMA_mem7, 0  );ArrayInitialize(dJMA_mem8,  0.0);
ArrayInitialize(nJMA_mem9,0  );ArrayInitialize(nJMA_countR1,0);ArrayInitialize(nJMA_countR2,0);ArrayInitialize(nJMA_countL,0  );
ArrayInitialize(dJMA_Kg,  0.0);ArrayInitialize(dJMA_Pf,   0.0);ArrayInitialize(dJMA_f18,  0.0);ArrayInitialize(dJMA_f38,   0.0);
ArrayInitialize(dJMA_fA8, 0.0);ArrayInitialize(dJMA_fC0,  0.0);ArrayInitialize(dJMA_fC8,  0.0);ArrayInitialize(dJMA_s8,    0.0);
ArrayInitialize(dJMA_s18, 0.0);ArrayInitialize(dJMA_JMA,  0.0);ArrayInitialize(nJMA_s50,  0  );ArrayInitialize(nJMA_s70,   0  );
ArrayInitialize(nJMA_LP2, 0  );ArrayInitialize(nJMA_LP1,  0  );ArrayInitialize(nJMA_s38,  0  );ArrayInitialize(nJMA_s40,   0  );
ArrayInitialize(nJMA_s48, 0  );ArrayInitialize(dJMA_v1,   0  );ArrayInitialize(dJMA_v2,   0  );ArrayInitialize(dJMA_v3,    0  );
ArrayInitialize(dJMA_f90, 0.0);ArrayInitialize(dJMA_f78,  0.0);ArrayInitialize(dJMA_f88,  0.0);ArrayInitialize(dJMA_f98,   0.0);
ArrayInitialize(nJMA_s28, 0  );ArrayInitialize(nJMA_s30,  0  );ArrayInitialize(nJMA_f0,   1  );
//--+
nJMA_reset=0;return(1);
//----++SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
}

nJMA_reset=1;
if (nJMA_bar> nJMA_MaxBar){nJMA_reset=0;return(0.0);}
nJMA_n=nJMA_number;
if((nJMA_bar==nJMA_MaxBar)||(nJMA_din!=0))
{
//----++ <<<    >>> +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
double Dr,Ds,Dl;
if(nJMA_Length < 1.0000000002) Dr = 0.0000000001;
else Dr= (nJMA_Length - 1.0) / 2.0;
if((nJMA_Phase >= -100)&&(nJMA_Phase <= 100))dJMA_Pf[nJMA_n] = nJMA_Phase / 100.0 + 1.5;
if (nJMA_Phase > 100) dJMA_Pf[nJMA_n] = 2.5;
if (nJMA_Phase < -100) dJMA_Pf[nJMA_n] = 0.5;
Dr = Dr * 0.9; dJMA_Kg[nJMA_n] = Dr/(Dr + 2.0);
Ds=MathSqrt(Dr);Dl=MathLog(Ds); dJMA_v1[nJMA_n]= Dl;dJMA_v2[nJMA_n] = dJMA_v1[nJMA_n];
if((dJMA_v1[nJMA_n] / MathLog(2.0)) + 2.0 < 0.0) dJMA_v3[nJMA_n]= 0.0;
else dJMA_v3[nJMA_n]=(dJMA_v2[nJMA_n]/MathLog(2.0))+ 2.0;
dJMA_f98[nJMA_n]= dJMA_v3[nJMA_n];
if( dJMA_f98[nJMA_n] >= 2.5 ) dJMA_f88[nJMA_n] = dJMA_f98[nJMA_n] - 2.0;
else dJMA_f88[nJMA_n]= 0.5;
dJMA_f78[nJMA_n]= Ds * dJMA_f98[nJMA_n]; dJMA_f90[nJMA_n]= dJMA_f78[nJMA_n] / (dJMA_f78[nJMA_n] + 1.0);
//----++SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
}
if(nJMA_bar==nJMA_MaxBar)
{
//----+----------------------------------------------------------------+
nJMA_f0[nJMA_n]=1; nJMA_s28[nJMA_n]=63; nJMA_s30[nJMA_n]=64;
for(int kk=0;kk<=nJMA_s28[nJMA_n];kk++)dJMA_list[nJMA_n][kk]=-1000000.0;
for(kk=nJMA_s30[nJMA_n]; kk<=127; kk++)dJMA_list[nJMA_n][kk]= 1000000.0;
//----+----------------------------------------------------------------+
}
//--+
if((nJMA_bar==nJMA_limit)&&(nJMA_limit<nJMA_MaxBar))
{
//----+ <<<    >>> +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
  int nJMA_Tnew=Time[nJMA_limit+1];
  //--+   
  if(nJMA_Tnew!=nJMA_mem2[nJMA_n][01])
    {
     nJMA_reset=-1;
     //--+       nJMA_limit  JJMASeries()
     if (nJMA_Tnew>nJMA_mem2[nJMA_n][01])
       {
       Print("JJMASeries number ="+nJMA_n+". ERROR01");
       Print("JJMASeries number ="+nJMA_n+".  nJMA_limit  JJMASeries ,  ");
       }
    else 
       { 
       int nJMA_LimitERROR=nJMA_limit+1-iBarShift(NULL,0,nJMA_mem2[nJMA_n][01],TRUE);
       Print("JMASerries number ="+nJMA_n+". ERROR02");
       Print("JJMASeries number ="+nJMA_n+".  nJMA_limit  JJMASeries ,   "+nJMA_LimitERROR+"");
       }
  //--+   nJMA_reset=-1;     JJMASeries
  return(0);
  }
//--+
for(nJMA_ii=nJMA_countL [nJMA_n]-1;nJMA_ii>=0;nJMA_ii--)
                     {nJMA_temp=nJMA_mem9[nJMA_n][nJMA_ii];dJMA_list [nJMA_n][nJMA_temp]=dJMA_mem8[nJMA_n][nJMA_ii];}
  
for(nJMA_ii=nJMA_countR1[nJMA_n]-1;nJMA_ii>=0;nJMA_ii--)
                     {nJMA_temp=nJMA_mem6[nJMA_n][nJMA_ii];dJMA_ring1[nJMA_n][nJMA_temp]=dJMA_mem4[nJMA_n][nJMA_ii];}
  
for(nJMA_ii=nJMA_countR2[nJMA_n]-1;nJMA_ii>=0;nJMA_ii--)
                     {nJMA_temp=nJMA_mem7[nJMA_n][nJMA_ii];dJMA_ring2[nJMA_n][nJMA_temp]=dJMA_mem5[nJMA_n][nJMA_ii];}
//--+
dJMA_fC0[nJMA_n]=dJMA_mem1[nJMA_n][00];dJMA_fC8[nJMA_n]=dJMA_mem1[nJMA_n][01];dJMA_fA8[nJMA_n]=dJMA_mem1[nJMA_n][02];
dJMA_s8 [nJMA_n]=dJMA_mem1[nJMA_n][03];dJMA_f18[nJMA_n]=dJMA_mem1[nJMA_n][04];dJMA_f38[nJMA_n]=dJMA_mem1[nJMA_n][05];
dJMA_s18[nJMA_n]=dJMA_mem1[nJMA_n][06];dJMA_JMA[nJMA_n]=dJMA_mem1[nJMA_n][07];nJMA_s38[nJMA_n]=nJMA_mem2[nJMA_n][02];
nJMA_s48[nJMA_n]=nJMA_mem2[nJMA_n][03];nJMA_s50[nJMA_n]=nJMA_mem2[nJMA_n][04];nJMA_LP1[nJMA_n]=nJMA_mem2[nJMA_n][05];
nJMA_LP2[nJMA_n]=nJMA_mem2[nJMA_n][06];nJMA_s40[nJMA_n]=nJMA_mem2[nJMA_n][07];nJMA_s70[nJMA_n]=nJMA_mem2[nJMA_n][08];
//----+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
}
if (nJMA_bar>1){nJMA_countR1[nJMA_n]=0;nJMA_countR2[nJMA_n]=0;nJMA_countL[nJMA_n]=0;}
//----+
if (nJMA_LP1[nJMA_n]<61){nJMA_LP1[nJMA_n]++; dJMA_buffer[nJMA_n][nJMA_LP1[nJMA_n]]=dJMA_series;}
if (nJMA_LP1[nJMA_n]>30)
{
//++++++++++++++++++
if (nJMA_f0[nJMA_n] != 0)
{
nJMA_f0[nJMA_n] = 0; nJMA_v5 = 0;
for( nJMA_ii=0; nJMA_ii<=29; nJMA_ii++) if (dJMA_buffer[nJMA_n][nJMA_ii+1] != dJMA_buffer[nJMA_n][nJMA_ii]){ nJMA_v5 = 1; break; }
nJMA_fD8 = nJMA_v5*30;
if (nJMA_fD8 == 0) dJMA_f38[nJMA_n] = dJMA_series; else dJMA_f38[nJMA_n] = dJMA_buffer[nJMA_n][1];
dJMA_f18[nJMA_n] = dJMA_f38[nJMA_n];
if (nJMA_fD8 > 29) nJMA_fD8 = 29;
}
else nJMA_fD8 = 0;
for(nJMA_ii=nJMA_fD8; nJMA_ii>=0; nJMA_ii--)
{
nJMA_val=31-nJMA_ii;
if (nJMA_ii == 0) dJMA_f8 = dJMA_series; else dJMA_f8 = dJMA_buffer[nJMA_n][nJMA_val];
dJMA_f28 = dJMA_f8 - dJMA_f18[nJMA_n]; dJMA_f48 = dJMA_f8 - dJMA_f38[nJMA_n];
if (MathAbs(dJMA_f28) > MathAbs(dJMA_f48)) dJMA_v2[nJMA_n] = MathAbs(dJMA_f28); else dJMA_v2[nJMA_n] = MathAbs(dJMA_f48);
dJMA_fA0 = dJMA_v2[nJMA_n]; dJMA_vv = dJMA_fA0 + 0.0000000001; //{1.0e-10;}
if (nJMA_s48[nJMA_n] <= 1) nJMA_s48[nJMA_n] = 127; else nJMA_s48[nJMA_n] = nJMA_s48[nJMA_n] - 1;
if (nJMA_s50[nJMA_n] <= 1) nJMA_s50[nJMA_n] = 10;  else nJMA_s50[nJMA_n] = nJMA_s50[nJMA_n] - 1;
if (nJMA_s70[nJMA_n] < 128) nJMA_s70[nJMA_n] = nJMA_s70[nJMA_n] + 1;
dJMA_s8[nJMA_n] = dJMA_s8[nJMA_n] + dJMA_vv - dJMA_ring2[nJMA_n][nJMA_s50[nJMA_n]];

if(nJMA_bar<=1)
{
//--+ <<<      >>> +ssssssssssssssssss+
dJMA_mem5[nJMA_n][nJMA_countR2[nJMA_n]]=dJMA_ring2[nJMA_n][nJMA_s50[nJMA_n]];
nJMA_mem7[nJMA_n][nJMA_countR2[nJMA_n]]=nJMA_s50[nJMA_n];nJMA_countR2[nJMA_n]++;
//--++sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss+
}
dJMA_ring2[nJMA_n][nJMA_s50[nJMA_n]] = dJMA_vv;
if (nJMA_s70[nJMA_n] > 10) dJMA_s20 = dJMA_s8[nJMA_n] / 10.0; else dJMA_s20 = dJMA_s8[nJMA_n] / nJMA_s70[nJMA_n];
if (nJMA_s70[nJMA_n] > 127)
{
dJMA_s10 = dJMA_ring1[nJMA_n][nJMA_s48[nJMA_n]];

if(nJMA_bar<=1)
{
//--+ <<<      >>> +sssssssssssssssssss+
dJMA_mem4[nJMA_n][nJMA_countR1[nJMA_n]]=dJMA_ring1[nJMA_n][nJMA_s48[nJMA_n]];
nJMA_mem6[nJMA_n][nJMA_countR1[nJMA_n]]=nJMA_s48[nJMA_n];nJMA_countR1[nJMA_n]++;
//--++ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss+
}
dJMA_ring1[nJMA_n][nJMA_s48[nJMA_n]] = dJMA_s20; nJMA_s68 = 64; nJMA_s58 = nJMA_s68;
while (nJMA_s68 > 1)
{
if (dJMA_list[nJMA_n][nJMA_s58] < dJMA_s10){nJMA_s68 = nJMA_s68 *0.5; nJMA_s58 = nJMA_s58 + nJMA_s68;}
else 
if (dJMA_list[nJMA_n][nJMA_s58]<= dJMA_s10) nJMA_s68 = 1; else{nJMA_s68 = nJMA_s68 *0.5; nJMA_s58 = nJMA_s58 - nJMA_s68;}
}
}
else
{
if(nJMA_bar<=1)
{
//--+ <<<      >>> +sssssssssssssssssss+
dJMA_mem4[nJMA_n][nJMA_countR1[nJMA_n]]=dJMA_ring1[nJMA_n][nJMA_s48[nJMA_n]];
nJMA_mem6[nJMA_n][nJMA_countR1[nJMA_n]]=nJMA_s48[nJMA_n];nJMA_countR1[nJMA_n]++;
//--++ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss+
}
dJMA_ring1[nJMA_n][nJMA_s48[nJMA_n]] = dJMA_s20;
if  (nJMA_s28[nJMA_n] + nJMA_s30[nJMA_n] > 127){nJMA_s30[nJMA_n] = nJMA_s30[nJMA_n] - 1; nJMA_s58 = nJMA_s30[nJMA_n];}
else{nJMA_s28[nJMA_n] = nJMA_s28[nJMA_n] + 1; nJMA_s58 = nJMA_s28[nJMA_n];}
if  (nJMA_s28[nJMA_n] > 96) nJMA_s38[nJMA_n] = 96; else nJMA_s38[nJMA_n] = nJMA_s28[nJMA_n];
if  (nJMA_s30[nJMA_n] < 32) nJMA_s40[nJMA_n] = 32; else nJMA_s40[nJMA_n] = nJMA_s30[nJMA_n];
}
nJMA_s68 = 64; nJMA_s60 = nJMA_s68;
while (nJMA_s68 > 1)
{
if (dJMA_list[nJMA_n][nJMA_s60] >= dJMA_s20)
{
if (dJMA_list[nJMA_n][nJMA_s60 - 1] <= dJMA_s20) nJMA_s68 = 1; else {nJMA_s68 = nJMA_s68 *0.5; nJMA_s60 = nJMA_s60 - nJMA_s68; }
}
else{nJMA_s68 = nJMA_s68 *0.5; nJMA_s60 = nJMA_s60 + nJMA_s68;}
if ((nJMA_s60 == 127) && (dJMA_s20 > dJMA_list[nJMA_n][127])) nJMA_s60 = 128;
}
if (nJMA_s70[nJMA_n] > 127)
{
if (nJMA_s58 >= nJMA_s60)
{
if ((nJMA_s38[nJMA_n] + 1 > nJMA_s60) && (nJMA_s40[nJMA_n] - 1 < nJMA_s60)) dJMA_s18[nJMA_n] = dJMA_s18[nJMA_n] + dJMA_s20;
else 
if ((nJMA_s40[nJMA_n] + 0 > nJMA_s60) && (nJMA_s40[nJMA_n] - 1 < nJMA_s58)) dJMA_s18[nJMA_n] 
= dJMA_s18[nJMA_n] + dJMA_list[nJMA_n][nJMA_s40[nJMA_n] - 1];
}
else
if (nJMA_s40[nJMA_n] >= nJMA_s60) {if ((nJMA_s38[nJMA_n] + 1 < nJMA_s60) && (nJMA_s38[nJMA_n] + 1 > nJMA_s58)) dJMA_s18[nJMA_n] 
= dJMA_s18[nJMA_n] + dJMA_list[nJMA_n][nJMA_s38[nJMA_n] + 1]; }
else if  (nJMA_s38[nJMA_n] + 2 > nJMA_s60) dJMA_s18[nJMA_n] = dJMA_s18[nJMA_n] + dJMA_s20; 
else if ((nJMA_s38[nJMA_n] + 1 < nJMA_s60) && (nJMA_s38[nJMA_n] + 1 > nJMA_s58)) dJMA_s18[nJMA_n] 
= dJMA_s18[nJMA_n] + dJMA_list[nJMA_n][nJMA_s38[nJMA_n] + 1];
if (nJMA_s58 > nJMA_s60)
{
if ((nJMA_s40[nJMA_n] - 1 < nJMA_s58) && (nJMA_s38[nJMA_n] + 1 > nJMA_s58)) dJMA_s18[nJMA_n] = dJMA_s18[nJMA_n] - dJMA_list[nJMA_n][nJMA_s58];
else 
if ((nJMA_s38[nJMA_n]     < nJMA_s58) && (nJMA_s38[nJMA_n] + 1 > nJMA_s60)) dJMA_s18[nJMA_n] = dJMA_s18[nJMA_n] - dJMA_list[nJMA_n][nJMA_s38[nJMA_n]];
}
else
{
if ((nJMA_s38[nJMA_n] + 1 > nJMA_s58) && (nJMA_s40[nJMA_n] - 1 < nJMA_s58)) dJMA_s18[nJMA_n] = dJMA_s18[nJMA_n] - dJMA_list[nJMA_n][nJMA_s58];
else
if ((nJMA_s40[nJMA_n] + 0 > nJMA_s58) && (nJMA_s40[nJMA_n] - 0 < nJMA_s60)) dJMA_s18[nJMA_n] = dJMA_s18[nJMA_n] - dJMA_list[nJMA_n][nJMA_s40[nJMA_n]];
}
}
if (nJMA_s58 <= nJMA_s60)
{
if (nJMA_s58 >= nJMA_s60)
{
if(nJMA_bar<=1)
{
//--+ <<<      >>> +ssssssssss+
dJMA_mem8[nJMA_n][nJMA_countL[nJMA_n]]=dJMA_list[nJMA_n][nJMA_s60];
nJMA_mem9[nJMA_n][nJMA_countL[nJMA_n]]=nJMA_s60;nJMA_countL[nJMA_n]++;
//--++sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss+
}
dJMA_list[nJMA_n][nJMA_s60] = dJMA_s20;
}
else
{
if(nJMA_bar<=1)
{
//--+ <<<      >>> +sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss+
nJMA_size=nJMA_s60-nJMA_s58;for(nJMA_aa=0; nJMA_aa<=nJMA_size-2;nJMA_aa++){dJMA_mem8[nJMA_n][nJMA_countL[nJMA_n]+nJMA_aa]
=dJMA_list[nJMA_n][nJMA_s58+nJMA_aa];nJMA_mem9[nJMA_n][nJMA_countL[nJMA_n]+nJMA_aa]=nJMA_s58+1+nJMA_aa;}
nJMA_countL[nJMA_n]=nJMA_countL[nJMA_n]+nJMA_size;dJMA_mem8[nJMA_n][nJMA_countL[nJMA_n]]=dJMA_list[nJMA_n][nJMA_s60-1];
nJMA_mem9[nJMA_n][nJMA_countL[nJMA_n]]=nJMA_s60-1;nJMA_countL[nJMA_n]++;
//--++ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss+
}
for( nJMA_jj = nJMA_s58 + 1; nJMA_jj<=nJMA_s60 - 1 ;nJMA_jj++)dJMA_list[nJMA_n][nJMA_jj - 1] = dJMA_list[nJMA_n][nJMA_jj];
dJMA_list[nJMA_n][nJMA_s60 - 1] = dJMA_s20;
}
}
else
{
if(nJMA_bar<=1)
{
//--+ <<<      >>> +ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss+
nJMA_size=nJMA_s58-nJMA_s60+1;for(nJMA_aa=0; nJMA_aa<=nJMA_size-2;nJMA_aa++){dJMA_mem8[nJMA_n][nJMA_countL[nJMA_n]+nJMA_aa]
=dJMA_list[nJMA_n][nJMA_s58-nJMA_aa];nJMA_mem9[nJMA_n][nJMA_countL[nJMA_n]+nJMA_aa]=nJMA_s58-1-nJMA_aa;}
nJMA_countL[nJMA_n]=nJMA_countL[nJMA_n]+nJMA_size;dJMA_mem8[nJMA_n][nJMA_countL[nJMA_n]]=dJMA_list[nJMA_n][nJMA_s60];
nJMA_mem9[nJMA_n][nJMA_countL[nJMA_n]]=nJMA_s60;nJMA_countL[nJMA_n]++;
//--++sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss+
}
for( nJMA_jj = nJMA_s58 - 1; nJMA_jj>=nJMA_s60 ;nJMA_jj--) dJMA_list[nJMA_n][nJMA_jj + 1] = dJMA_list[nJMA_n][nJMA_jj];
dJMA_list[nJMA_n][nJMA_s60] = dJMA_s20;
}
if (nJMA_s70[nJMA_n] <= 127)
{
dJMA_s18[nJMA_n] = 0;
for( nJMA_jj = nJMA_s40[nJMA_n] ; nJMA_jj<=nJMA_s38[nJMA_n] ;nJMA_jj++) dJMA_s18[nJMA_n] = dJMA_s18[nJMA_n] + dJMA_list[nJMA_n][nJMA_jj];
}
dJMA_f60 = dJMA_s18[nJMA_n] / (nJMA_s38[nJMA_n] - nJMA_s40[nJMA_n] + 1.0);
if (nJMA_LP2[nJMA_n] + 1 > 31) nJMA_LP2[nJMA_n] = 31; else nJMA_LP2[nJMA_n] = nJMA_LP2[nJMA_n] + 1;
if (nJMA_LP2[nJMA_n] <= 30)
{
if (dJMA_f28 > 0.0) dJMA_f18[nJMA_n] = dJMA_f8; else dJMA_f18[nJMA_n] = dJMA_f8 - dJMA_f28 * dJMA_f90[nJMA_n];
if (dJMA_f48 < 0.0) dJMA_f38[nJMA_n] = dJMA_f8; else dJMA_f38[nJMA_n] = dJMA_f8 - dJMA_f48 * dJMA_f90[nJMA_n];
dJMA_JMA[nJMA_n] = dJMA_series;
if (nJMA_LP2[nJMA_n]!=30) continue;
if (nJMA_LP2[nJMA_n]==30)
{
dJMA_fC0[nJMA_n] = dJMA_series;
if ( MathCeil(dJMA_f78[nJMA_n]) >= 1) dJMA_v4 = MathCeil(dJMA_f78[nJMA_n]); else dJMA_v4 = 1.0;

if(dJMA_v4>0)nJMA_fE8 = MathFloor(dJMA_v4);else{if(dJMA_v4<0)nJMA_fE8 = MathCeil (dJMA_v4);else nJMA_fE8 = 0.0;}

if (MathFloor(dJMA_f78[nJMA_n]) >= 1) dJMA_v2[nJMA_n] = MathFloor(dJMA_f78[nJMA_n]); else dJMA_v2[nJMA_n] = 1.0;

if(dJMA_v2[nJMA_n]>0)nJMA_fE0 = MathFloor(dJMA_v2[nJMA_n]);else{if(dJMA_v2[nJMA_n]<0)nJMA_fE0 = MathCeil (dJMA_v2[nJMA_n]);else nJMA_fE0 = 0.0;}

if (nJMA_fE8== nJMA_fE0) dJMA_f68 = 1.0; else {dJMA_v4 = nJMA_fE8 - nJMA_fE0; dJMA_f68 = (dJMA_f78[nJMA_n] - nJMA_fE0) / dJMA_v4;}
if (nJMA_fE0 <= 29) nJMA_v5 = nJMA_fE0; else nJMA_v5 = 29;
if (nJMA_fE8 <= 29) nJMA_v6 = nJMA_fE8; else nJMA_v6 = 29;
dJMA_fA8[nJMA_n] = (dJMA_series - dJMA_buffer[nJMA_n][nJMA_LP1[nJMA_n] - nJMA_v5]) * (1.0 - dJMA_f68) / nJMA_fE0 + (dJMA_series 
- dJMA_buffer[nJMA_n][nJMA_LP1[nJMA_n] - nJMA_v6]) * dJMA_f68 / nJMA_fE8;
}
}
else
{
if (dJMA_f98[nJMA_n] >= MathPow(dJMA_fA0/dJMA_f60, dJMA_f88[nJMA_n])) dJMA_v1[nJMA_n] = MathPow(dJMA_fA0/dJMA_f60, dJMA_f88[nJMA_n]);
else dJMA_v1[nJMA_n] = dJMA_f98[nJMA_n];
if (dJMA_v1[nJMA_n] < 1.0) dJMA_v2[nJMA_n] = 1.0;
else
{if(dJMA_f98[nJMA_n] >= MathPow(dJMA_fA0/dJMA_f60, dJMA_f88[nJMA_n])) dJMA_v3[nJMA_n] = MathPow(dJMA_fA0/dJMA_f60, dJMA_f88[nJMA_n]);
else dJMA_v3[nJMA_n] = dJMA_f98[nJMA_n]; dJMA_v2[nJMA_n] = dJMA_v3[nJMA_n];}
dJMA_f58 = dJMA_v2[nJMA_n]; dJMA_f70 = MathPow(dJMA_f90[nJMA_n], MathSqrt(dJMA_f58));
if (dJMA_f28 > 0.0) dJMA_f18[nJMA_n] = dJMA_f8; else dJMA_f18[nJMA_n] = dJMA_f8 - dJMA_f28 * dJMA_f70;
if (dJMA_f48 < 0.0) dJMA_f38[nJMA_n] = dJMA_f8; else dJMA_f38[nJMA_n] = dJMA_f8 - dJMA_f48 * dJMA_f70;
}
}
if (nJMA_LP2[nJMA_n] >30)
{
dJMA_f30 = MathPow(dJMA_Kg[nJMA_n], dJMA_f58);
dJMA_fC0[nJMA_n] =(1.0 - dJMA_f30) * dJMA_series + dJMA_f30 * dJMA_fC0[nJMA_n];
dJMA_fC8[nJMA_n] =(dJMA_series - dJMA_fC0[nJMA_n]) * (1.0 - dJMA_Kg[nJMA_n]) + dJMA_Kg[nJMA_n] * dJMA_fC8[nJMA_n];
dJMA_fD0 = dJMA_Pf[nJMA_n] * dJMA_fC8[nJMA_n] + dJMA_fC0[nJMA_n];
dJMA_f20 = dJMA_f30 *(-2.0);
dJMA_f40 = dJMA_f30 * dJMA_f30;
dJMA_fB0 = dJMA_f20 + dJMA_f40 + 1.0;
dJMA_fA8[nJMA_n] =(dJMA_fD0 - dJMA_JMA[nJMA_n]) * dJMA_fB0 + dJMA_f40 * dJMA_fA8[nJMA_n];
dJMA_JMA[nJMA_n] = dJMA_JMA[nJMA_n] + dJMA_fA8[nJMA_n];
}
}
//++++++++++++++++++
if (nJMA_LP1[nJMA_n] <=30)dJMA_JMA[nJMA_n]=0.0;
if (nJMA_bar==2)
{
//--+ <<<    >>> +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
dJMA_mem1[nJMA_n][00]=dJMA_fC0[nJMA_n];dJMA_mem1[nJMA_n][01]=dJMA_fC8[nJMA_n];dJMA_mem1[nJMA_n][02]=dJMA_fA8[nJMA_n];
dJMA_mem1[nJMA_n][03]= dJMA_s8[nJMA_n];dJMA_mem1[nJMA_n][04]=dJMA_f18[nJMA_n];dJMA_mem1[nJMA_n][05]=dJMA_f38[nJMA_n];
dJMA_mem1[nJMA_n][06]=dJMA_s18[nJMA_n];dJMA_mem1[nJMA_n][07]=dJMA_JMA[nJMA_n];nJMA_mem2[nJMA_n][02]=nJMA_s38[nJMA_n];
nJMA_mem2[nJMA_n][03]=nJMA_s48[nJMA_n];nJMA_mem2[nJMA_n][04]=nJMA_s50[nJMA_n];nJMA_mem2[nJMA_n][05]=nJMA_LP1[nJMA_n];
nJMA_mem2[nJMA_n][06]=nJMA_LP2[nJMA_n];nJMA_mem2[nJMA_n][07]=nJMA_s40[nJMA_n];nJMA_mem2[nJMA_n][08]=nJMA_s70[nJMA_n];
nJMA_mem2[nJMA_n][00]=Time[1];nJMA_mem2[nJMA_n][01]=Time[2];
//--+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
}
//----+  done --------------------------+
nJMA_reset=0;
return(dJMA_JMA[nJMA_n]);
}

//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
// JJMASeriesReset -           | 
// JJMASeries.  : if (limit==Bars-1)JJMASeriesReset(5);  5 -       | 
//   JJMASeries                                                        |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
void JJMASeriesReset(int nJJMAReset_Number)
 {
  int nJJMAReset_reset=-1;
  int nJJMAReset_set=JJMASeries(nJJMAReset_Number,0,0,0,0,0,0,0,nJJMAReset_reset);
  if((nJJMAReset_set==1)&&(nJJMAReset_reset==0))Print("JJMASeriesReset is OK!!!");
  else Print("JJMASeriesReset is ERROR!!!");
 }
//--+ --------------------------------------------------------------------------------------------+

/*
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
 INDICATOR_COUNTED() -           | 
 . Ÿ     ,              |
        .            |
        IndicatorCounted()         |
      ,   !            INDICATOR_COUNTED()  | 
     IndicatorCounted()                          |
 INDICATOR_COUNTED_Input=0;      ,      |
  INDICATOR_COUNTED_Input = 1;     ,      |
        int start()             | 
  .       INDICATOR_COUNTED_Input = -1;            |             
    ,   ,    return(-1);    |
   int start().                                                                         |
  :                                                                                |
                                                                                                  |
//----+                                      |
//----             |
incounted_bars=INDICATOR_COUNTED(0); INDICATOR_COUNTED(1);                                        |
//----                                                                   |
if (counted_bars<0){INDICATOR_COUNTED(-1); return(-1);}                                           |
//----                                                |
if (counted_bars>0) counted_bars--;                                                               |
//----     ,         |
int limit=Bars-1-counted_bars;                                                                    |
//----                                                                                            |
for(bar=limit;bar>=0;bar--) {    }                                             |
      return(-1)   int start();           |
  {INDICATOR_COUNTED(-1);return(-1);}                                                   |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
*/
int  INDICATOR_COUNTED(int INDICATOR_COUNTED_Input) 
//----+ 
{   
  int INDICATOR_COUNTED_counted_bars;
  //----+ xxxxxxxxxxx
  if (INDICATOR_COUNTED_Input == 1)
    {
      //----      
      static int INDICATOR_COUNTED_T2, INDICATOR_COUNTED_Period; 
      INDICATOR_COUNTED_counted_bars=IndicatorCounted(); 
      if (INDICATOR_COUNTED_counted_bars<0)
       {
        //INDICATOR_COUNTED_T2=0; 
        return(INDICATOR_COUNTED_counted_bars);
       }
       //----+       
      INDICATOR_COUNTED_T2 =Time[2]; 
      INDICATOR_COUNTED_Period=Period();
      return(INDICATOR_COUNTED_counted_bars);
    }
  INDICATOR_COUNTED_counted_bars=IndicatorCounted(); 
  if (INDICATOR_COUNTED_counted_bars<0)
    {
    INDICATOR_COUNTED_T2=0; 
    return(INDICATOR_COUNTED_counted_bars);
    }
  //----+
  if((INDICATOR_COUNTED_counted_bars!=0)&&(IsConnected()==TRUE)&&(INDICATOR_COUNTED_T2==0))
         {
          //     INDICATOR_COUNTED     
          Print("INDICATOR_COUNTED:       ");
          Print("INDICATOR_COUNTED:     ");
          Print("INDICATOR_COUNTED:        ");
          Print("INDICATOR_COUNTED:        ");
          Print("INDICATOR_COUNTED:        ");
        //PlaySound("wait.wav");
          return(0); 
         }
  //----+ xxxxxxxxxxx
  if ((INDICATOR_COUNTED_Input==0)&&(INDICATOR_COUNTED_Period==Period()))
    {
     if((INDICATOR_COUNTED_counted_bars==0)&&(IsConnected()==TRUE))
      { 
       //Print("INDICATOR_COUNTED:       ");  
       //Print("INDICATOR_COUNTED:   INDICATOR_COUNTED()     ");
       if (INDICATOR_COUNTED_T2 == 0)
         {
          //     INDICATOR_COUNTED     
          Print("INDICATOR_COUNTED:       ");
          Print("INDICATOR_COUNTED:     ");
          Print("INDICATOR_COUNTED:        ");
          Print("INDICATOR_COUNTED:        ");
          Print("INDICATOR_COUNTED:        ");
        //PlaySound("wait.wav");
          return(0); 
         }
        //----+         
       int INDICATOR_COUNTED_BarShift=iBarShift(NULL,0,INDICATOR_COUNTED_T2,TRUE); 
       if ((INDICATOR_COUNTED_BarShift<2)||(INDICATOR_COUNTED_T2!=Time[INDICATOR_COUNTED_BarShift]))
         {
          //     INDICATOR_COUNTED     
          Print("INDICATOR_COUNTED:       ");
          Print("INDICATOR_COUNTED:     ");
          Print("INDICATOR_COUNTED:        ");
          Print("INDICATOR_COUNTED:        ");
          Print("INDICATOR_COUNTED:        ");
        //PlaySound("wait.wav");
          return(0); 
         }
       int INDICATOR_COUNTED_Resalt=Bars-1-INDICATOR_COUNTED_BarShift+2;
       //     INDICATOR_COUNTED     
     //Print("INDICATOR_COUNTED:       "); 
     //Print("INDICATOR_COUNTED:       "); 
     //Print("INDICATOR_COUNTED:    ");
     //Print("INDICATOR_COUNTED:       "+INDICATOR_COUNTED_Resalt+"");
     //Print("INDICATOR_COUNTED:       "+INDICATOR_COUNTED_BarShift+" ");
     //Print("INDICATOR_COUNTED: BarShift ="+INDICATOR_COUNTED_BarShift+" INDICATOR_COUNTED_T2 ="+INDICATOR_COUNTED_T2+""); 
       return(INDICATOR_COUNTED_Resalt); 
      }
     else return(INDICATOR_COUNTED_counted_bars);
    }
   //----+ xxxxxxxxxxx
  if (INDICATOR_COUNTED_Input ==-1)
   { 
    INDICATOR_COUNTED_T2 =0; 
    INDICATOR_COUNTED_Period=-1; 
    Print("INDICATOR_COUNTED:    ");
    Print("INDICATOR_COUNTED:   int start()    return(-1)");
  //PlaySound("stops.wav");  
    return(0); 
   }
  return(INDICATOR_COUNTED_counted_bars);
}
//--+ --------------------------------------------------------------------------------------------+

